/*
 * $Header: ociapr.h 7020200.1 95/02/15 18:37:30 cli Generic<base> $ 
 */

/* Copyright (c) 1991 by Oracle Corporation */
/*
   NAME
     ociapr.h
   MODIFIED   (MM/DD/YY)
    dchatter   02/08/95 -  olog call; drop onblon
    dchatter   10/31/94 -  new functions for non-blocking oci
    rkooi2     11/27/92 -  Changing datatypes to agree with ocidef.h 
    rkooi2     10/26/92 -  More portability mods 
    rkooi2     10/18/92 -  Changed to agree with oci.c 
    sjain      03/16/92 -  Creation 
*/
/*
 *  Declare the OCI functions.
 *  Prototype information is included.
 *  Use this header for ANSI C compilers.
 */

#ifndef OCIAPR
#define OCIAPR

#include <oratypes.h>
#include <ocidfn.h>



sword  obndra   (struct cda_def *cursor, text *sqlvar, sword sqlvl,
                 ub1 *progv, sword progvl, sword ftype, sword scale,
                 sb2 *indp, ub2 *alen, ub2 *arcode, ub4 maxsiz,
                 ub4 *cursiz, text *fmt, sword fmtl, sword fmtt);
sword  obndrn   (struct cda_def *cursor, sword sqlvn, ub1 *progv,
                 sword progvl, sword ftype, sword scale, sb2 *indp,
                 text *fmt, sword fmtl, sword fmtt);
sword  obndrv   (struct cda_def *cursor, text *sqlvar, sword sqlvl,
                 ub1 *progv, sword progvl, sword ftype, sword scale,
                 sb2 *indp, text *fmt, sword fmtl, sword fmtt);
sword  obreak   (struct cda_def *lda);
sword  ocan     (struct cda_def *cursor);
sword  oclose   (struct cda_def *cursor);
sword  ocof     (struct cda_def *lda);
sword  ocom     (struct cda_def *lda);
sword  ocon     (struct cda_def *lda);
sword  odefin   (struct cda_def *cursor, sword pos, ub1 *buf,
                 sword bufl, sword ftype, sword scale, sb2 *indp,
                 text *fmt, sword fmtl, sword fmtt, ub2 *rlen, ub2 *rcode);
sword  odessp   (struct cda_def *cursor, text *objnam, size_t onlen,
                 ub1 *rsv1, size_t rsv1ln, ub1 *rsv2, size_t rsv2ln,
                 ub2 *ovrld, ub2 *pos, ub2 *level, text **argnam,
                 ub2 *arnlen, ub2 *dtype, ub1 *defsup, ub1* mode,
                 ub4 *dtsiz, sb2 *prec, sb2 *scale, ub1 *radix,
                 ub4 *spare, ub4 *arrsiz);
sword  odescr   (struct cda_def *cursor, sword pos, sb4 *dbsize,
                 sb2 *dbtype, sb1 *cbuf, sb4 *cbufl, sb4 *dsize,
                 sb2 *prec, sb2 *scale, sb2 *nullok);
sword  oerhms   (struct cda_def *lda, sb2 rcode, text *buf,
                 sword bufsiz);
sword  oermsg   (sb2 rcode, text *buf);
sword  oexec    (struct cda_def *cursor);
sword  oexfet   (struct cda_def *cursor, ub4 nrows,
                 sword cancel, sword exact);
sword  oexn     (struct cda_def *cursor, sword iters, sword rowoff);
sword  ofen     (struct cda_def *cursor, sword nrows);
sword  ofetch   (struct cda_def *cursor);
sword  oflng    (struct cda_def *cursor, sword pos, ub1 *buf,
                 sb4 bufl, sword dtype, ub4 *retl, sb4 offset);
sword  olog     (struct cda_def *lda, ub1* hda,
                 text *uid, sword uidl,
                 text *pswd, sword pswdl, 
                 text *conn, sword connl, 
                 ub4 mode);
sword  ologof   (struct cda_def *lda);
sword  oopen    (struct cda_def *cursor, struct cda_def *lda,
                 text *dbn, sword dbnl, sword arsize,
                 text *uid, sword uidl);
sword  oparse   (struct cda_def *cursor, text *sqlstm, sb4 sqllen,
                 sword defflg, ub4 lngflg);
sword  orol     (struct cda_def *lda);


void sqlld2     (struct cda_def *lda, text *cname, sb4 *cnlen);
void sqllda     (struct cda_def *lda);

/* non-blocking functions */

sword onbset    (struct cda_def *lda ); 
sword onbtst    (struct cda_def *lda ); 
sword onbclr    (struct cda_def *lda ); 
sword  oopt     (struct cda_def *cursor, sword rbopt, sword waitopt);


/* older calls ; preferred equivalent calls above */

sword  oname    (struct cda_def *cursor, sword pos, sb1 *tbuf,
                 sb2 *tbufl, sb1 *buf, sb2 *bufl);
sword  orlon    (struct cda_def *lda, ub1 *hda, 
                 text *uid, sword uidl, 
                 text *pswd, sword pswdl, 
                 sword audit);
sword  olon     (struct cda_def *lda, text *uid, sword uidl,
                 text *pswd, sword pswdl, sword audit);
sword  osql3    (struct cda_def *cda, text *sqlstm, sword sqllen);
sword  odsc     (struct cda_def *cursor, sword pos, sb2 *dbsize,
                 sb2 *fsize, sb2 *rcode, sb2 *dtype, sb1 *buf,
                 sb2 *bufl, sb2 *dsize);

#endif /* OCIAPR */


